;----------------------------________________-------------------------------
;---------------------------|                |------------------------------
;---------------------------|  BUTTON LAYOUT |------------------------------
;---------------------------|________________|------------------------------

;XYZ
;ABC START

;X - punch
;Y - kick
;Z - grab
;A - Punch Supers (S1)
;B - Kick Supers (S2)
;C - assist (striker)


; SUPER MOVES
;***************************************************************

; Super moves are done by pressing S1 (A) or S2 (b) with some directional input or neutral.
; S1 makes punch related supers and S2 makes kicks related supers


; HYPER MOVES (level 1)
;***************************************************************

; Super moves are done by pressing S1+Punch (A+X) or S2+kick (B+Y) with some directional input or neutral.
; S1+Punch makes punch related hypers and S2+kick  makes kicks related hypers

; ULTRA MOVES (level 3)
;***************************************************************

; Ultra moves, or levvl 3 hypers, are done by pressing S1+S2 (X+Y) and are limited to
; ONLY ONE per character (transformed chars can have one for each transformations)





; The CMD file.
;
; Two parts: 1. Command definition and  2. State entry
; (state entry is after the commands def section)
;
; 1. Command definition
; ---------------------
; Note: The commands are CASE-SENSITIVE, and so are the command names.
; The eight directions are:
;   B, DB, D, DF, F, UF, U, UB     (all CAPS)
;   corresponding to back, down-back, down, downforward, etc.
; The six buttons are:
;   a, b, c, x, y, z               (all lower case)
;   In default key config, abc are are the bottom, and xyz are on the
;   top row. For 2 button characters, we recommend you use a and b.
;   For 6 button characters, use abc for kicks and xyz for punches.
;
; Each [Command] section defines a command that you can use for
; state entry, as well as in the CNS file.
; The command section should look like:
;
;   [Command]
;   name = some_name
;   command = the_command
;   time = time (optional -- defaults to 15 if omitted)
;
; - some_name
;   A name to give that command. You'll use this name to refer to
;   that command in the state entry, as well as the CNS. It is case-
;   sensitive (QCB_a is NOT the same as Qcb_a or QCB_A).
;
; - command
;   list of buttons or directions, separated by commas.
;   Directions and buttons can be preceded by special characters:
;   slash (/) - means the key must be held down
;          egs. command = /D       ;hold the down direction
;               command = /DB, a   ;hold down-back while you press a
;   tilde (~) - to detect key releases
;          egs. command = ~a       ;release the a button
;               command = ~D, F, a ;release down, press fwd, then a
;          If you want to detect "charge moves", you can specify
;          the time the key must be held down for (in game-ticks)
;          egs. command = ~30a     ;hold a for at least 30 ticks, then release
;   dollar ($) - Direction-only: detect as 4-way
;          egs. command = $D       ;will detect if D, DB or DF is held
;               command = $B       ;will detect if B, DB or UB is held
;   plus (+) - Buttons only: simultaneous press
;          egs. command = a+b      ;press a and b at the same time
;               command = x+y+z    ;press x, y and z at the same time
;   You can combine them:
;     eg. command = ~30$D, a+b     ;hold D, DB or DF for 30 ticks, release,
;                                  ;then press a and b together
;   It's recommended that for most "motion" commads, eg. quarter-circle-fwd,
;   you start off with a "release direction". This matches the way most
;   popular fighting games implement their command detection.
;
; - time (optional)
;   Time allowed to do the command, given in game-ticks. Defaults to 15
;   if omitted
;
; If you have two or more commands with the same name, all of them will
; work. You can use it to allow multiple motions for the same move.
;
;-| Button Remapping |-----------------------------------------------------
; This section lets you remap the player's buttons (to easily change the
; button configuration). The format is:
;   old_button = new_button
; If new_button is left blank, the button cannot be pressed.
[Remap]
x = x
y = y
z = z
a = a
b = b
c = c
s = s

;-| Default Values |-------------------------------------------------------
[Defaults]
; Default value for the "time" parameter of a Command. Minimum 1.
command.time = 15

; Default value for the "buffer.time" parameter of a Command. Minimum 1,
; maximum 30.
command.buffer.time = 1

;-| Single Button |---------------------------------------------------------
[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd" ;Required (do not remove)
command = /$F
time = 1

[Command]
name = "holddown" ;Required (do not remove)
command = /$D
time = 1

[Command]
name = "holdback" ;Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

;-| Hold Button |----------------------------------------------------------
[Command]
name = "holda"
command = /a
time = 1

[Command]
name = "holdb"
command = /b
time = 1

[Command]
name = "holdc"
command = /c
time = 1

[Command]
name = "holdx"
command = /x
time = 1

[Command]
name = "holdy"
command = /y
time = 1

[Command]
name = "holdz"
command = /z
time = 1

[Command]
name = "holdstart"
command = /s
time = 1

;-| CPU |--------------------------------------------------------------
[Command]
name = "a2"
command = a
time = 1

[Command]
name = "b2"
command = b
time = 1

[Command]
name = "c2"
command = c
time = 1

[Command]
name = "x2"
command = x
time = 1

[Command]
name = "y2"
command = y
time = 1

[Command]
name = "z2"
command = z
time = 1

[Command]
name = "start2"
command = s
time = 1

[Command]
name = "holdfwd2"
command = /$F
time = 1

[Command]
name = "holdback2"
command = /$B
time = 1

[Command]
name = "holdup2"
command = /$U
time = 1

[Command]
name = "holddown2"
command = /$D
time = 1

[Command]
name = "holda2"
command = /a
time = 1

[Command]
name = "holdb2"
command = /b
time = 1

[Command]
name = "holdc2"
command = /c
time = 1

[Command]
name = "holdx2"
command = /x
time = 1

[Command]
name = "holdy2"
command = /y
time = 1

[Command]
name = "holdz2"
command = /z
time = 1

[Command]
name = "holdstart2"
command = /s
time = 1

[Command]
name = "recovery2"
command = x+y
time = 1


;----------------------------________________-------------------------------
;---------------------------|                |------------------------------
;---------------------------|   basic move   |------------------------------
;---------------------------|________________|------------------------------
;---------------------------------------------------------------------------
; superjump
[command]
name = "superjump"
command = $D, $U
time = 30


;-| Double Tap |-----------------------------------------------------------
[Command]
name = "FF"     ;Required (do not remove)
command = F, F
time = 10

[Command]
name = "BB"     ;Required (do not remove)
command = B, B
time = 10

;-| 2/3 Button Combination |-----------------------------------------------

[Command]
name = "recovery" ;Required (do not remove)
command = x+y
time = 1

[Command]
name = "recovery"
command = y+z
time = 1

[Command]
name = "recovery"
command = x+z
time = 1

[Command]
name = "recovery"
command = a+b
time = 1

[Command]
name = "recovery"
command = b+c
time = 1

[Command]
name = "recovery"
command = a+c
time = 1

;-| Hyper Motions |--------------------------------------------------------

[Command]
name = "hyper1"
command = a+x
time = 1

[Command]
name = "hyper2"
command = b+y
time = 1

[Command]
name = "ultra"
command = a+b
time = 1

;---------------------------------------------------------------------------
; 2. State entry
; --------------
; This is where you define what commands bring you to what states.
;
; Each state entry block looks like:
;   [State -1, Label]           ;Change Label to any name you want to use to
;                               ;identify the state with.
;   type = ChangeState          ;Don't change this
;   value = new_state_number
;   trigger1 = command = command_name
;   . . .  (any additional triggers)
;
; - new_state_number is the number of the state to change to
; - command_name is the name of the command (from the section above)
; - Useful triggers to know:
;   - statetype
;       S, C or A : current state-type of player (stand, crouch, air)
;   - ctrl
;       0 or 1 : 1 if player has control. Unless "interrupting" another
;                move, you'll want ctrl = 1
;   - stateno
;       number of state player is in - useful for "move interrupts"
;   - movecontact
;       0 or 1 : 1 if player's last attack touched the opponent
;                useful for "move interrupts"
;
; Note: The order of state entry is important.
;   State entry with a certain command must come before another state
;   entry with a command that is the subset of the first.  
;   For example, command "fwd_a" must be listed before "a", and
;   "fwd_ab" should come before both of the others.
;
; For reference on triggers, see CNS documentation.
;
; Just for your information (skip if you're not interested):
; This part is an extension of the CNS. "State -1" is a special state
; that is executed once every game-tick, regardless of what other state
; you are in.


; Don't remove the following line. It's required by the CMD standard.
[Statedef -1]

;----------------------------________________-------------------------------
;---------------------------|                |------------------------------
;---------------------------|   Hyper moves  |------------------------------
;---------------------------|________________|------------------------------
;---------------------------------------------------------------------------


;---------------------------------------------------------------------------
; 
[state -1, ]
type = null;changestate
value = 4000
triggerall = command = "ultra"
triggerall = !var(0)
triggerall = power >= 3000
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)
trigger8 = stateno = 1001 && MoveContact

;---------------------------------------------------------------------------
; Gamma Rock 'n' Roll
[state -1, Gamma Rock 'n' Roll]
type = changestate
value = 3100
triggerall = command = "hyper1"  && StateType !=A
triggerall = command != "holddown"
triggerall = !var(0)
triggerall = power >= 1000
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)
trigger8 = stateno = 1001 && MoveContact

;---------------------------------------------------------------------------
; Gamma Clap
[state -1, Gamma Clap]
type = changestate
value = 3000
triggerall = command = "hyper2"
triggerall = !var(0)
triggerall = power >= 1000
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)
trigger8 = stateno = 1001 && MoveContact

;---------------------------------------------------------------------------
; 
[state -1,]
type = null;changestate
value = 3300
triggerall = command = "hyper1"
triggerall = command = "holddown" && StateType !=A
triggerall = !var(0)
triggerall = power >= 1000
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)
trigger8 = stateno = 1001 && MoveContact

;----------------------------________________-------------------------------
;---------------------------|                |------------------------------
;---------------------------|  special move  |------------------------------
;---------------------------|________________|------------------------------
;---------------------------------------------------------------------------

;---------------------------------------------------------------------------
; Gamma Palm
[state -1, Gamma Palm]
type = changestate
value = 1000
triggerall = command = "a"
triggerall = command = "holddown"
triggerall = !var(0)
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
; Gamma Stone
[state -1, Gamma Stone]
type = changestate
value = 1100
triggerall = command = "a" && statetype != A
triggerall = command != "holddown" || command != "holdback"
triggerall = !var(0)
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
; 
[state -1, ]
type = null;changestate
value = 1150
triggerall = command = "b"
triggerall = command = "holddown"
triggerall = !var(0)
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [300,360]
trigger4 = movecontact
trigger5 = stateno = [500, 505]
trigger5 = movecontact
trigger6 = stateno = [100,105]
trigger6 = time >= 4
trigger7 = movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
; 
[state -1, ]
type = null;changestate
value = 1200
triggerall = command = "a"
triggerall = command = "holddown"
triggerall = !var(0) && PalNo >=7 && StateType != A
trigger1 = ctrl
trigger2 = stateno = 200
trigger2 = movecontact
trigger3 = stateno = 250
trigger3 = movecontact
trigger4 = stateno = [100,105]
trigger4 = time >= 4
trigger5 = (statetype = S) && movecontact && (Var(15) > 0)




;---------------------------------------------------------------------------
;---------------------------------- jump -----------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
; super jump
[state -1, super jump]
type = changestate
value = 890
triggerall = !var(0)
triggerall = command = "superjump"
trigger1 = statetype != a
trigger1 = ctrl = 1

;===========================================================================
;---------------------------------------------------------------------------
; Run Fwd
[State -1, Run Fwd]
type = ChangeState
value = 100
trigger1 = command = "FF"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
; Run Back
[State -1, Run Back]
type = ChangeState
value = 105
trigger1 = command = "BB"
trigger1 = statetype = S
trigger1 = ctrl


;---------------------------------------------------------------------------
; aerial rave Follow-jump
[state -1,aerial rave Follow-jump]
type = changestate
value = 400
triggerall = !var(0)
triggerall = command = "holdup"
trigger1 = numtarget(300)
trigger1 = !target, hitshakeover
trigger1 = target, stateno > 150
trigger1 = stateno = 300

;---------------------------------------------------------------------------
; air launcher UP
[state -1, air launcher UP]
type = changestate
value = 510
trigger1 = !var(0)
trigger1 = !var(10)
trigger1 = command = "holdup"
trigger1 = command = "x"
trigger1 = command = "y"
trigger1 = stateNo = [500,505]
trigger1 = numtarget

;---------------------------------------------------------------------------
; air launcher fwd
[state -1, air launcher fwd]
type = changestate
value = 520
trigger1 = !var(0)
trigger1 = !var(11)
trigger1 = command = "holdfwd"
trigger1 = command = "x"
trigger1 = command = "y"
trigger1 = stateNo = [500,505]
trigger1 = numtarget

;---------------------------------------------------------------------------
; air launcher fwd
[state -1, air launcher fwd]
type = changestate
value = 530
trigger1 = !var(0)
trigger1 = !var(12)
trigger1 = command = "holdback"
trigger1 = command = "x"
trigger1 = command = "y"
trigger1 = stateNo = [500,505]
trigger1 = numtarget

;---------------------------------------------------------------------------
; air launcher DOWN
[state -1, air launcher DOWN]
type = changestate
value = 550+var(10)+var(11)+var(12)
trigger1 = !var(0)
trigger1 = command = "holddown"
trigger1 = command = "x"
trigger1 = command = "y"
trigger1 = stateNo = [500,505]
trigger1 = numtarget

;---------------------------------------------------------------------------
; Throw
[State -1, Throw]
type = ChangeState
value = 800
triggerall = statetype != A
triggerall = stateno != 100 && ctrl
trigger1 = command = "z"

;---------------------------------------------------------------------------
; Striker
[State -1, Striker]
type = ChangeState
value = 750
triggerall = Var(16)
triggerall = statetype != A && !NumHelper(755)
triggerall = stateno != 100 && ctrl
trigger1 = command = "c"
;===========================================================================
;---------------------------------------------------------------------------
; Taunt
[State -1, Taunt]
type = ChangeState
value = 195
triggerall = !var(0)
triggerall = command = "start"
trigger1 = statetype != A
trigger1 = ctrl

;---------------------------------------------------------------------------
; Stand Light Punch
[State -1, Stand Light Punch]
type = ChangeState
value = 200
triggerall = !var(0)
triggerall = command = "x"
triggerall = command != "holddown"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = (statetype = S) && movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
; Standing Light Kick
[State -1, Standing Light Kick]
type = ChangeState
value = 250
triggerall = !var(0)
triggerall = command = "y"
triggerall = command != "holddown"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
; Launcher
[State -1, Launcher]
type = ChangeState
value = 300
triggerall = !var(0)
triggerall = command = "x"
triggerall = command = "holddown"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = movecontact && (Var(15) > 0) && Enemynear, stateno >150

;---------------------------------------------------------------------------
; Sweep
[State -1, Sweep]
type = ChangeState
value = 310
triggerall = !var(0)
triggerall = command = "y"
triggerall = command = "holddown"
trigger1 = statetype != A
trigger1 = ctrl
trigger2 = movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
;----------------------------- jumping punch -------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
; jumping punch
[state -1, state -1]
type = changestate
value = 350
triggerall = !var(0)
triggerall = command = "x"
triggerAll = statetype = a
trigger1 = ctrl = 1
trigger2 = stateno = 500
trigger2 = movecontact
trigger3 = (statetype = A) && movecontact && (Var(15) > 0)

;---------------------------------------------------------------------------
; jumping kick
[state -1, state -1]
type = changestate
value = 360
triggerall = !var(0)
triggerall = command = "y"
triggerAll = statetype = a
trigger1 = ctrl = 1
trigger2 = stateno = 500
trigger2 = movecontact
trigger3 = (statetype = A) && movecontact && (Var(15) > 0)

